<?php

namespace Opentalent\OtTemplating\ViewHelpers;


use Closure;
use Opentalent\OtTemplating\Utilities\OtPageRepository;
use Opentalent\OtTemplating\ViewHelpers\RootPage\GetIdViewHelper;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;

/**
 * Returns the uid of the page with the given slug
 * if it exists in the current website,
 * else returns null
 *
 *     {namespace ot=Opentalent\OtTemplating\ViewHelpers}
 *
 *     {ot:pageExists(slug: 'foo')}
 *
 * @package Opentalent\OtTemplating\ViewHelpers
 */
class GetPageUidViewHelper extends AbstractViewHelper
{

    /**
     * -- This method is expected by Fluid --
     * Declares the viewhelper's parameters
     */
    public function initializeArguments()
    {
        $this->registerArgument(
            'slug',
            'string',
            'The slug of the researched page',
            true
        );
    }

    /**
     * -- This method is expected by Fluid --
     * Renders the content as html
     *
     * @param array $arguments
     * @param Closure $renderChildrenClosure
     * @param RenderingContextInterface $renderingContext
     * @return int|null
     */
    public static function renderStatic(
        array $arguments,
        Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $rootId = GetIdViewHelper::renderStatic(
            $arguments,
            $renderChildrenClosure,
            $renderingContext
        );

        $pageRepository = new OtPageRepository();

        $subpages = $pageRepository->getAllSubpagesForPage($rootId);

        foreach ($subpages as $page) {
            if ($page['slug'] === $arguments['slug']) {
                return $page['uid'];
            }
        }
        return null;
    }

}
